searchNodes=[{"doc":"Public interface functions of RaftedValue package.","ref":"RaftedValue.html","title":"RaftedValue","type":"module"},{"doc":"Replaces the current configuration. The new configuration is replicated (as raft log) to all members.","ref":"RaftedValue.html#change_config/2","title":"RaftedValue.change_config/2","type":"function"},{"doc":"Executes a command on the stored value of leader . id is an identifier of the command and can be used to filter out duplicate requests. If the leader does not respond in a timely manner, the function returns {:error, :timeout} , i.e., it internally catches exit. Caller process should be prepared to handle delayed reply (e.g. by dropping delayed reply by handle_info(_msg, state) ).","ref":"RaftedValue.html#command/5","title":"RaftedValue.command/5","type":"function"},{"doc":"Tells a member to forget about another member. The sole purpose of this function is to recover a consensus group from majority failure. This operation is unsafe in the sense that it may not preserve invariants of the Raft algorithm (for example some committed logs may be lost); use this function as a last resort. Membership change introduced by this function is not propagated to other members. It is caller's responsibility to stop member_to_remove if it is still alive before calling this function, and to notify all existing members of the removal (i.e. call this function for all existing members).","ref":"RaftedValue.html#force_remove_member/2","title":"RaftedValue.force_remove_member/2","type":"function"},{"doc":"Make a new instance of RaftedValue.Config struct. data_module must be an implementation of RaftedValue.Data behaviour. Available options: leader_hook_module : An implementation of RaftedValue.LeaderHook . Defaults to RaftedValue.LeaderHook.NoOp . communication_module : A module to define member-to-member async communication ( cast/2 and reply/2 ). Defaults to RaftedValue.RemoteMessageGateway . This is useful for performance optimizations (and also internal testing). heartbeat_timeout : Raft's heartbeat timeout in milliseconds. Defaults to 200 . election_timeout : Raft's leader election timeout in milliseconds. The acrual timeout value in each member is randomly chosen from election_timeout .. 2 * election_timeout . Defaults to 1000 . election_timeout_clock_drift_margin : A time margin in milliseconds to judge whether leader lease has expired or not. When a leader gets responses from majority it gets a lease for election_timeout - margin . During the lease time the leader can assume that no other members are ever elected leader. This enables the leader to skip message round trips during processing read-only query. Defaults to the value of election_timeout (i.e. no lease time, disabling this clock-based optimization). max_retained_command_results : Number of command results to be cached, in order not to doubly apply the same command due to client retries. Defaults to 100 .","ref":"RaftedValue.html#make_config/2","title":"RaftedValue.make_config/2","type":"function"},{"doc":"Executes a read-only query on the stored value of leader . If the leader does not respond in a timely manner, the function returns {:error, :timeout} , i.e., it internally catches exit. Caller process should be prepared to handle delayed reply (e.g. by dropping delayed reply by handle_info(_msg, state) ).","ref":"RaftedValue.html#query/4","title":"RaftedValue.query/4","type":"function"},{"doc":"Executes a read-only query on the stored value of the specified member. Unlike query/3 , this variant allows non-leader members to reply to the query. Return value of this function can be stale; it may not reflect recent updates.","ref":"RaftedValue.html#query_non_leader/3","title":"RaftedValue.query_non_leader/3","type":"function"},{"doc":"Obtains last log index from the log files stored in dir .","ref":"RaftedValue.html#read_last_log_index/1","title":"RaftedValue.read_last_log_index/1","type":"function"},{"doc":"Removes a follower from a consensus group.","ref":"RaftedValue.html#remove_follower/2","title":"RaftedValue.remove_follower/2","type":"function"},{"doc":"Replaces current leader of a consensus group from current_leader to new_leader . By specifying nil as new_leader , you can cancel the previously-issued and stuck attempt of replacing leader.","ref":"RaftedValue.html#replace_leader/2","title":"RaftedValue.replace_leader/2","type":"function"},{"doc":"Starts a new member of consensus group. The 1st argument specifies the consensus group to belong to: {:create_new_consensus_group, config} : Creates a new consensus group using the given RaftedValue.Config.t . The group's sole member is the newly-spawned process and it immediately becomes leader. {:join_existing_consensus_group, members} : Joins an already running consensus group as a follower. The 2nd argument is a keyword list of options to specify member-specific configurations. :name : An atom for local name registration. :persistence_dir : Directory path in which both Raft logs and periodic snapshots are stored. If not given, the newly-spawned process will run in in-memory mode; it does not persist its state. The specified directory will be created if it does not exist. Note that it's caller's responsibility to ensure that the specified directory is not used by other RaftedValue process. See below for details of restoring state from snapshot and logs. :log_file_expansion_factor : A number that adjusts when to make a snapshot file. This does not take effect if :persistence_dir is not given. RaftedValue keeps track of the file sizes of &quot;currently growing log file&quot; and &quot;previous snapshot file&quot;. A new snapshot is created when log_file_size &gt; previous_snapshot_size * expansion_factor . Small value means frequent snapshotting, which can result in high overhead. On the other hand larger expansion factor may lead to longer recovery time. Defaults to 10 . :spawn_opt : A keyword list of options to be passed to :erlang.spawn_opt/4 . Restoring state from snapshot and log files RaftedValue implements state recovery using log and snapshot files. The recovery procedure is triggered when: A new process is start_link ed with {:create_new_consensus_group, config} and :persistence_dir . Valid log and snapshot files exist in the given :persistence_dir . Then the newly-spawned process loads the latest snapshot and log files and forms a new 1-member consensus group with the restored Raft state (except for membership information). When restoring from snapshot and logs, config passed in the 1st argument is neglected in favor of configurations in the snapshot and logs. If you don't want to restore from snapshot and log files (i.e. want to start a consensus group from scratch), then you must clean up the directory before calling start_link/2 .","ref":"RaftedValue.html#start_link/2","title":"RaftedValue.start_link/2","type":"function"},{"doc":"Retrieves status of a member in a consensus group.","ref":"RaftedValue.html#status/2","title":"RaftedValue.status/2","type":"function"},{"doc":"","ref":"RaftedValue.html#t:command_identifier/0","title":"RaftedValue.command_identifier/0","type":"type"},{"doc":"","ref":"RaftedValue.html#t:consensus_group_info/0","title":"RaftedValue.consensus_group_info/0","type":"type"},{"doc":"","ref":"RaftedValue.html#t:not_leader/0","title":"RaftedValue.not_leader/0","type":"type"},{"doc":"","ref":"RaftedValue.html#t:option/0","title":"RaftedValue.option/0","type":"type"},{"doc":"","ref":"RaftedValue.html#t:remove_follower_error_reason/0","title":"RaftedValue.remove_follower_error_reason/0","type":"type"},{"doc":"","ref":"RaftedValue.html#t:replace_leader_error_reason/0","title":"RaftedValue.replace_leader_error_reason/0","type":"type"},{"doc":"","ref":"RaftedValue.html#t:status_result/0","title":"RaftedValue.status_result/0","type":"type"},{"doc":"","ref":"RaftedValue.CommandResults.html","title":"RaftedValue.CommandResults","type":"module"},{"doc":"","ref":"RaftedValue.CommandResults.html#fetch/2","title":"RaftedValue.CommandResults.fetch/2","type":"function"},{"doc":"","ref":"RaftedValue.CommandResults.html#new/0","title":"RaftedValue.CommandResults.new/0","type":"function"},{"doc":"","ref":"RaftedValue.CommandResults.html#put/4","title":"RaftedValue.CommandResults.put/4","type":"function"},{"doc":"","ref":"RaftedValue.CommandResults.html#valid?/1","title":"RaftedValue.CommandResults.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.CommandResults.html#t:cmd_id/0","title":"RaftedValue.CommandResults.cmd_id/0","type":"type"},{"doc":"","ref":"RaftedValue.CommandResults.html#t:t/0","title":"RaftedValue.CommandResults.t/0","type":"type"},{"doc":"","ref":"RaftedValue.Communication.html","title":"RaftedValue.Communication","type":"behaviour"},{"doc":"","ref":"RaftedValue.Communication.html#c:cast/2","title":"RaftedValue.Communication.cast/2","type":"callback"},{"doc":"","ref":"RaftedValue.Communication.html#c:reply/2","title":"RaftedValue.Communication.reply/2","type":"callback"},{"doc":"","ref":"RaftedValue.Config.html","title":"RaftedValue.Config","type":"module"},{"doc":"Type-aware getter for communication_module.","ref":"RaftedValue.Config.html#communication_module/1","title":"RaftedValue.Config.communication_module/1","type":"function"},{"doc":"Type-aware setter for communication_module.","ref":"RaftedValue.Config.html#communication_module/2","title":"RaftedValue.Config.communication_module/2","type":"function"},{"doc":"Type-aware getter for data_module.","ref":"RaftedValue.Config.html#data_module/1","title":"RaftedValue.Config.data_module/1","type":"function"},{"doc":"Type-aware setter for data_module.","ref":"RaftedValue.Config.html#data_module/2","title":"RaftedValue.Config.data_module/2","type":"function"},{"doc":"Type-aware getter for election_timeout.","ref":"RaftedValue.Config.html#election_timeout/1","title":"RaftedValue.Config.election_timeout/1","type":"function"},{"doc":"Type-aware setter for election_timeout.","ref":"RaftedValue.Config.html#election_timeout/2","title":"RaftedValue.Config.election_timeout/2","type":"function"},{"doc":"Type-aware getter for election_timeout_clock_drift_margin.","ref":"RaftedValue.Config.html#election_timeout_clock_drift_margin/1","title":"RaftedValue.Config.election_timeout_clock_drift_margin/1","type":"function"},{"doc":"Type-aware setter for election_timeout_clock_drift_margin.","ref":"RaftedValue.Config.html#election_timeout_clock_drift_margin/2","title":"RaftedValue.Config.election_timeout_clock_drift_margin/2","type":"function"},{"doc":"Type-aware getter for heartbeat_timeout.","ref":"RaftedValue.Config.html#heartbeat_timeout/1","title":"RaftedValue.Config.heartbeat_timeout/1","type":"function"},{"doc":"Type-aware setter for heartbeat_timeout.","ref":"RaftedValue.Config.html#heartbeat_timeout/2","title":"RaftedValue.Config.heartbeat_timeout/2","type":"function"},{"doc":"Type-aware getter for leader_hook_module.","ref":"RaftedValue.Config.html#leader_hook_module/1","title":"RaftedValue.Config.leader_hook_module/1","type":"function"},{"doc":"Type-aware setter for leader_hook_module.","ref":"RaftedValue.Config.html#leader_hook_module/2","title":"RaftedValue.Config.leader_hook_module/2","type":"function"},{"doc":"Type-aware getter for max_retained_command_results.","ref":"RaftedValue.Config.html#max_retained_command_results/1","title":"RaftedValue.Config.max_retained_command_results/1","type":"function"},{"doc":"Type-aware setter for max_retained_command_results.","ref":"RaftedValue.Config.html#max_retained_command_results/2","title":"RaftedValue.Config.max_retained_command_results/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.Config by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.Config.html#new/1","title":"RaftedValue.Config.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Config.html#new!/1","title":"RaftedValue.Config.new!/1","type":"function"},{"doc":"Updates an existing instance of RaftedValue.Config with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.Config.html#update/2","title":"RaftedValue.Config.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Config.html#update!/2","title":"RaftedValue.Config.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.Config.html#valid?/1","title":"RaftedValue.Config.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Config.html#t:t/0","title":"RaftedValue.Config.t/0","type":"type"},{"doc":"A behaviour that defines data to be replicated by RaftedValue servers. It is required to implement a callback module of this behaviour to run a consensus group. Concrete implementations of all callback functions of this behaviour must be pure , so that all members of a consensus group can reproduce the data by replicating only command_arg . Therefore, for example, if you want to use &quot;current time&quot; in your command implementation, you must not obtain current time in command/1 implementation; you have to pass it by embedding in command_arg . This is a design decision made to support arbitrary data structure while keeping Raft logs compact.","ref":"RaftedValue.Data.html","title":"RaftedValue.Data","type":"behaviour"},{"doc":"Generic read/write operation on the stored value. This callback function is invoked by RaftedValue.command/4 . Commands are replicated across members of the consensus group and executed in all members in order to reproduce the same history of stored value. This function should return a pair of &quot;return value to client&quot; and &quot;next version of stored data&quot;.","ref":"RaftedValue.Data.html#c:command/2","title":"RaftedValue.Data.command/2","type":"callback"},{"doc":"Creates an initial value to be stored. Whenever a new consensus group is started by RaftedValue.start_link/2 (called with :create_new_consensus_group ), this function is called to initialize the stored value.","ref":"RaftedValue.Data.html#c:new/0","title":"RaftedValue.Data.new/0","type":"callback"},{"doc":"Read-only operation on the stored value. This callback function is invoked by RaftedValue.query/3 . This function should return &quot;return value to client&quot;.","ref":"RaftedValue.Data.html#c:query/2","title":"RaftedValue.Data.query/2","type":"callback"},{"doc":"","ref":"RaftedValue.Data.html#t:command_arg/0","title":"RaftedValue.Data.command_arg/0","type":"type"},{"doc":"","ref":"RaftedValue.Data.html#t:command_ret/0","title":"RaftedValue.Data.command_ret/0","type":"type"},{"doc":"","ref":"RaftedValue.Data.html#t:data/0","title":"RaftedValue.Data.data/0","type":"type"},{"doc":"","ref":"RaftedValue.Data.html#t:query_arg/0","title":"RaftedValue.Data.query_arg/0","type":"type"},{"doc":"","ref":"RaftedValue.Data.html#t:query_ret/0","title":"RaftedValue.Data.query_ret/0","type":"type"},{"doc":"","ref":"RaftedValue.Election.html","title":"RaftedValue.Election","type":"module"},{"doc":"","ref":"RaftedValue.Election.html#gain_vote/3","title":"RaftedValue.Election.gain_vote/3","type":"function"},{"doc":"Type-aware getter for leader_message_at.","ref":"RaftedValue.Election.html#leader_message_at/1","title":"RaftedValue.Election.leader_message_at/1","type":"function"},{"doc":"Type-aware setter for leader_message_at.","ref":"RaftedValue.Election.html#leader_message_at/2","title":"RaftedValue.Election.leader_message_at/2","type":"function"},{"doc":"","ref":"RaftedValue.Election.html#minimum_timeout_elapsed_since_last_leader_message?/2","title":"RaftedValue.Election.minimum_timeout_elapsed_since_last_leader_message?/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.Election by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.Election.html#new/1","title":"RaftedValue.Election.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Election.html#new!/1","title":"RaftedValue.Election.new!/1","type":"function"},{"doc":"","ref":"RaftedValue.Election.html#new_for_follower/1","title":"RaftedValue.Election.new_for_follower/1","type":"function"},{"doc":"","ref":"RaftedValue.Election.html#new_for_leader/0","title":"RaftedValue.Election.new_for_leader/0","type":"function"},{"doc":"","ref":"RaftedValue.Election.html#reset_timer/2","title":"RaftedValue.Election.reset_timer/2","type":"function"},{"doc":"Type-aware getter for timer.","ref":"RaftedValue.Election.html#timer/1","title":"RaftedValue.Election.timer/1","type":"function"},{"doc":"Type-aware setter for timer.","ref":"RaftedValue.Election.html#timer/2","title":"RaftedValue.Election.timer/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.Election with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.Election.html#update/2","title":"RaftedValue.Election.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Election.html#update!/2","title":"RaftedValue.Election.update!/2","type":"function"},{"doc":"","ref":"RaftedValue.Election.html#update_for_candidate/2","title":"RaftedValue.Election.update_for_candidate/2","type":"function"},{"doc":"","ref":"RaftedValue.Election.html#update_for_follower/2","title":"RaftedValue.Election.update_for_follower/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.Election.html#valid?/1","title":"RaftedValue.Election.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Election.html#vote_for/3","title":"RaftedValue.Election.vote_for/3","type":"function"},{"doc":"Type-aware getter for voted_for.","ref":"RaftedValue.Election.html#voted_for/1","title":"RaftedValue.Election.voted_for/1","type":"function"},{"doc":"Type-aware setter for voted_for.","ref":"RaftedValue.Election.html#voted_for/2","title":"RaftedValue.Election.voted_for/2","type":"function"},{"doc":"Type-aware getter for votes.","ref":"RaftedValue.Election.html#votes/1","title":"RaftedValue.Election.votes/1","type":"function"},{"doc":"Type-aware setter for votes.","ref":"RaftedValue.Election.html#votes/2","title":"RaftedValue.Election.votes/2","type":"function"},{"doc":"","ref":"RaftedValue.Election.html#t:t/0","title":"RaftedValue.Election.t/0","type":"type"},{"doc":"","ref":"RaftedValue.FollowerIndices.html","title":"RaftedValue.FollowerIndices","type":"module"},{"doc":"","ref":"RaftedValue.FollowerIndices.html#valid?/1","title":"RaftedValue.FollowerIndices.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.FollowerIndices.html#t:t/0","title":"RaftedValue.FollowerIndices.t/0","type":"type"},{"doc":"","ref":"RaftedValue.FollowerIndices.Pair.html","title":"RaftedValue.FollowerIndices.Pair","type":"module"},{"doc":"","ref":"RaftedValue.FollowerIndices.Pair.html#valid?/1","title":"RaftedValue.FollowerIndices.Pair.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.FollowerIndices.Pair.html#t:t/0","title":"RaftedValue.FollowerIndices.Pair.t/0","type":"type"},{"doc":"A behaviour module for hooks that are invoked in leader. Note that there are cases where hooks are invoked multiple times for a single event due to leader change.","ref":"RaftedValue.LeaderHook.html","title":"RaftedValue.LeaderHook","type":"behaviour"},{"doc":"Hook to be called when a command submitted by RaftedValue.command/4 is committed.","ref":"RaftedValue.LeaderHook.html#c:on_command_committed/4","title":"RaftedValue.LeaderHook.on_command_committed/4","type":"callback"},{"doc":"Hook to be called when a new leader is elected in a consensus group.","ref":"RaftedValue.LeaderHook.html#c:on_elected/1","title":"RaftedValue.LeaderHook.on_elected/1","type":"callback"},{"doc":"Hook to be called when a new follower is added to a consensus group by RaftedValue.start_link/2 with :join_existing_consensus_group specified.","ref":"RaftedValue.LeaderHook.html#c:on_follower_added/2","title":"RaftedValue.LeaderHook.on_follower_added/2","type":"callback"},{"doc":"Hook to be called when a follower is removed from a consensus group by RaftedValue.remove_follower/2 .","ref":"RaftedValue.LeaderHook.html#c:on_follower_removed/2","title":"RaftedValue.LeaderHook.on_follower_removed/2","type":"callback"},{"doc":"Hook to be called when a query given by RaftedValue.query/3 is executed.","ref":"RaftedValue.LeaderHook.html#c:on_query_answered/3","title":"RaftedValue.LeaderHook.on_query_answered/3","type":"callback"},{"doc":"Hook to be called when a new leader restores its state from snapshot &amp; log files.","ref":"RaftedValue.LeaderHook.html#c:on_restored_from_files/1","title":"RaftedValue.LeaderHook.on_restored_from_files/1","type":"callback"},{"doc":"","ref":"RaftedValue.LeaderHook.html#t:neglected/0","title":"RaftedValue.LeaderHook.neglected/0","type":"type"},{"doc":"","ref":"RaftedValue.LeaderHook.NoOp.html","title":"RaftedValue.LeaderHook.NoOp","type":"module"},{"doc":"Callback implementation for RaftedValue.LeaderHook.on_command_committed/4 .","ref":"RaftedValue.LeaderHook.NoOp.html#on_command_committed/4","title":"RaftedValue.LeaderHook.NoOp.on_command_committed/4","type":"function"},{"doc":"Callback implementation for RaftedValue.LeaderHook.on_elected/1 .","ref":"RaftedValue.LeaderHook.NoOp.html#on_elected/1","title":"RaftedValue.LeaderHook.NoOp.on_elected/1","type":"function"},{"doc":"Callback implementation for RaftedValue.LeaderHook.on_follower_added/2 .","ref":"RaftedValue.LeaderHook.NoOp.html#on_follower_added/2","title":"RaftedValue.LeaderHook.NoOp.on_follower_added/2","type":"function"},{"doc":"Callback implementation for RaftedValue.LeaderHook.on_follower_removed/2 .","ref":"RaftedValue.LeaderHook.NoOp.html#on_follower_removed/2","title":"RaftedValue.LeaderHook.NoOp.on_follower_removed/2","type":"function"},{"doc":"Callback implementation for RaftedValue.LeaderHook.on_query_answered/3 .","ref":"RaftedValue.LeaderHook.NoOp.html#on_query_answered/3","title":"RaftedValue.LeaderHook.NoOp.on_query_answered/3","type":"function"},{"doc":"Callback implementation for RaftedValue.LeaderHook.on_restored_from_files/1 .","ref":"RaftedValue.LeaderHook.NoOp.html#on_restored_from_files/1","title":"RaftedValue.LeaderHook.NoOp.on_restored_from_files/1","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html","title":"RaftedValue.Leadership","type":"module"},{"doc":"","ref":"RaftedValue.Leadership.html#can_safely_remove?/4","title":"RaftedValue.Leadership.can_safely_remove?/4","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html#follower_responded/5","title":"RaftedValue.Leadership.follower_responded/5","type":"function"},{"doc":"Type-aware getter for follower_responded_times.","ref":"RaftedValue.Leadership.html#follower_responded_times/1","title":"RaftedValue.Leadership.follower_responded_times/1","type":"function"},{"doc":"Type-aware setter for follower_responded_times.","ref":"RaftedValue.Leadership.html#follower_responded_times/2","title":"RaftedValue.Leadership.follower_responded_times/2","type":"function"},{"doc":"Type-aware getter for heartbeat_timer.","ref":"RaftedValue.Leadership.html#heartbeat_timer/1","title":"RaftedValue.Leadership.heartbeat_timer/1","type":"function"},{"doc":"Type-aware setter for heartbeat_timer.","ref":"RaftedValue.Leadership.html#heartbeat_timer/2","title":"RaftedValue.Leadership.heartbeat_timer/2","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html#lease_expired?/3","title":"RaftedValue.Leadership.lease_expired?/3","type":"function"},{"doc":"Creates a new instance of RaftedValue.Leadership by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.Leadership.html#new/1","title":"RaftedValue.Leadership.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Leadership.html#new!/1","title":"RaftedValue.Leadership.new!/1","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html#new_for_leader/1","title":"RaftedValue.Leadership.new_for_leader/1","type":"function"},{"doc":"Type-aware getter for quorum_timer.","ref":"RaftedValue.Leadership.html#quorum_timer/1","title":"RaftedValue.Leadership.quorum_timer/1","type":"function"},{"doc":"Type-aware setter for quorum_timer.","ref":"RaftedValue.Leadership.html#quorum_timer/2","title":"RaftedValue.Leadership.quorum_timer/2","type":"function"},{"doc":"Type-aware getter for quorum_timer_started_at.","ref":"RaftedValue.Leadership.html#quorum_timer_started_at/1","title":"RaftedValue.Leadership.quorum_timer_started_at/1","type":"function"},{"doc":"Type-aware setter for quorum_timer_started_at.","ref":"RaftedValue.Leadership.html#quorum_timer_started_at/2","title":"RaftedValue.Leadership.quorum_timer_started_at/2","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html#remove_follower_response_time_entry/2","title":"RaftedValue.Leadership.remove_follower_response_time_entry/2","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html#reset_heartbeat_timer/2","title":"RaftedValue.Leadership.reset_heartbeat_timer/2","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html#reset_quorum_timer/2","title":"RaftedValue.Leadership.reset_quorum_timer/2","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html#stop_timers/1","title":"RaftedValue.Leadership.stop_timers/1","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html#unresponsive_followers/3","title":"RaftedValue.Leadership.unresponsive_followers/3","type":"function"},{"doc":"Updates an existing instance of RaftedValue.Leadership with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.Leadership.html#update/2","title":"RaftedValue.Leadership.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Leadership.html#update!/2","title":"RaftedValue.Leadership.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.Leadership.html#valid?/1","title":"RaftedValue.Leadership.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Leadership.html#t:t/0","title":"RaftedValue.Leadership.t/0","type":"type"},{"doc":"","ref":"RaftedValue.LogEntry.html","title":"RaftedValue.LogEntry","type":"module"},{"doc":"","ref":"RaftedValue.LogEntry.html#read_as_stream/1","title":"RaftedValue.LogEntry.read_as_stream/1","type":"function"},{"doc":"","ref":"RaftedValue.LogEntry.html#read_last_entry_index/1","title":"RaftedValue.LogEntry.read_last_entry_index/1","type":"function"},{"doc":"","ref":"RaftedValue.LogEntry.html#to_binary/1","title":"RaftedValue.LogEntry.to_binary/1","type":"function"},{"doc":"","ref":"RaftedValue.LogEntry.html#valid?/1","title":"RaftedValue.LogEntry.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.LogEntry.html#t:t/0","title":"RaftedValue.LogEntry.t/0","type":"type"},{"doc":"","ref":"RaftedValue.LogIndex.html","title":"RaftedValue.LogIndex","type":"module"},{"doc":"","ref":"RaftedValue.LogIndex.html#min/0","title":"RaftedValue.LogIndex.min/0","type":"function"},{"doc":"","ref":"RaftedValue.LogIndex.html#valid?/1","title":"RaftedValue.LogIndex.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.LogIndex.html#t:t/0","title":"RaftedValue.LogIndex.t/0","type":"type"},{"doc":"","ref":"RaftedValue.LogInfo.html","title":"RaftedValue.LogInfo","type":"module"},{"doc":"","ref":"RaftedValue.LogInfo.html#valid?/1","title":"RaftedValue.LogInfo.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.LogInfo.html#t:t/0","title":"RaftedValue.LogInfo.t/0","type":"type"},{"doc":"","ref":"RaftedValue.Logs.html","title":"RaftedValue.Logs","type":"module"},{"doc":"","ref":"RaftedValue.Logs.html#add_entry/3","title":"RaftedValue.Logs.add_entry/3","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#add_entry_on_add_follower/4","title":"RaftedValue.Logs.add_entry_on_add_follower/4","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#add_entry_on_elected_leader/4","title":"RaftedValue.Logs.add_entry_on_elected_leader/4","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#add_entry_on_remove_follower/4","title":"RaftedValue.Logs.add_entry_on_remove_follower/4","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#add_entry_on_restored_from_files/2","title":"RaftedValue.Logs.add_entry_on_restored_from_files/2","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#append_entries/5","title":"RaftedValue.Logs.append_entries/5","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#candidate_log_up_to_date?/2","title":"RaftedValue.Logs.candidate_log_up_to_date?/2","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#commit_to_latest/2","title":"RaftedValue.Logs.commit_to_latest/2","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#contain_given_prev_log?/2","title":"RaftedValue.Logs.contain_given_prev_log?/2","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#decrement_next_index_of_follower/2","title":"RaftedValue.Logs.decrement_next_index_of_follower/2","type":"function"},{"doc":"Type-aware getter for followers.","ref":"RaftedValue.Logs.html#followers/1","title":"RaftedValue.Logs.followers/1","type":"function"},{"doc":"Type-aware setter for followers.","ref":"RaftedValue.Logs.html#followers/2","title":"RaftedValue.Logs.followers/2","type":"function"},{"doc":"Type-aware getter for i_committed.","ref":"RaftedValue.Logs.html#i_committed/1","title":"RaftedValue.Logs.i_committed/1","type":"function"},{"doc":"Type-aware setter for i_committed.","ref":"RaftedValue.Logs.html#i_committed/2","title":"RaftedValue.Logs.i_committed/2","type":"function"},{"doc":"Type-aware getter for i_max.","ref":"RaftedValue.Logs.html#i_max/1","title":"RaftedValue.Logs.i_max/1","type":"function"},{"doc":"Type-aware setter for i_max.","ref":"RaftedValue.Logs.html#i_max/2","title":"RaftedValue.Logs.i_max/2","type":"function"},{"doc":"Type-aware getter for i_min.","ref":"RaftedValue.Logs.html#i_min/1","title":"RaftedValue.Logs.i_min/1","type":"function"},{"doc":"Type-aware setter for i_min.","ref":"RaftedValue.Logs.html#i_min/2","title":"RaftedValue.Logs.i_min/2","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#last_committed_entry/1","title":"RaftedValue.Logs.last_committed_entry/1","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#last_entry/1","title":"RaftedValue.Logs.last_entry/1","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#make_append_entries_req/4","title":"RaftedValue.Logs.make_append_entries_req/4","type":"function"},{"doc":"Type-aware getter for map.","ref":"RaftedValue.Logs.html#map/1","title":"RaftedValue.Logs.map/1","type":"function"},{"doc":"Type-aware setter for map.","ref":"RaftedValue.Logs.html#map/2","title":"RaftedValue.Logs.map/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.Logs by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.Logs.html#new/1","title":"RaftedValue.Logs.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Logs.html#new!/1","title":"RaftedValue.Logs.new!/1","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#new_for_lonely_leader/2","title":"RaftedValue.Logs.new_for_lonely_leader/2","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#new_for_new_follower/1","title":"RaftedValue.Logs.new_for_new_follower/1","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#set_follower_index/6","title":"RaftedValue.Logs.set_follower_index/6","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#set_follower_index_as_snapshot_last_index/4","title":"RaftedValue.Logs.set_follower_index_as_snapshot_last_index/4","type":"function"},{"doc":"Updates an existing instance of RaftedValue.Logs with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.Logs.html#update/2","title":"RaftedValue.Logs.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Logs.html#update!/2","title":"RaftedValue.Logs.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.Logs.html#valid?/1","title":"RaftedValue.Logs.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Logs.html#t:t/0","title":"RaftedValue.Logs.t/0","type":"type"},{"doc":"","ref":"RaftedValue.LogsMap.html","title":"RaftedValue.LogsMap","type":"module"},{"doc":"","ref":"RaftedValue.LogsMap.html#valid?/1","title":"RaftedValue.LogsMap.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.LogsMap.html#t:t/0","title":"RaftedValue.LogsMap.t/0","type":"type"},{"doc":"","ref":"RaftedValue.Members.html","title":"RaftedValue.Members","type":"module"},{"doc":"Type-aware getter for all.","ref":"RaftedValue.Members.html#all/1","title":"RaftedValue.Members.all/1","type":"function"},{"doc":"Type-aware setter for all.","ref":"RaftedValue.Members.html#all/2","title":"RaftedValue.Members.all/2","type":"function"},{"doc":"","ref":"RaftedValue.Members.html#force_remove_member/2","title":"RaftedValue.Members.force_remove_member/2","type":"function"},{"doc":"Type-aware getter for leader.","ref":"RaftedValue.Members.html#leader/1","title":"RaftedValue.Members.leader/1","type":"function"},{"doc":"Type-aware setter for leader.","ref":"RaftedValue.Members.html#leader/2","title":"RaftedValue.Members.leader/2","type":"function"},{"doc":"","ref":"RaftedValue.Members.html#membership_change_committed/2","title":"RaftedValue.Members.membership_change_committed/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.Members by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.Members.html#new/1","title":"RaftedValue.Members.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Members.html#new!/1","title":"RaftedValue.Members.new!/1","type":"function"},{"doc":"","ref":"RaftedValue.Members.html#new_for_lonely_leader/0","title":"RaftedValue.Members.new_for_lonely_leader/0","type":"function"},{"doc":"","ref":"RaftedValue.Members.html#other_members_list/1","title":"RaftedValue.Members.other_members_list/1","type":"function"},{"doc":"Type-aware getter for pending_leader_change.","ref":"RaftedValue.Members.html#pending_leader_change/1","title":"RaftedValue.Members.pending_leader_change/1","type":"function"},{"doc":"Type-aware setter for pending_leader_change.","ref":"RaftedValue.Members.html#pending_leader_change/2","title":"RaftedValue.Members.pending_leader_change/2","type":"function"},{"doc":"","ref":"RaftedValue.Members.html#put_leader/2","title":"RaftedValue.Members.put_leader/2","type":"function"},{"doc":"","ref":"RaftedValue.Members.html#start_adding_follower/2","title":"RaftedValue.Members.start_adding_follower/2","type":"function"},{"doc":"","ref":"RaftedValue.Members.html#start_removing_follower/2","title":"RaftedValue.Members.start_removing_follower/2","type":"function"},{"doc":"","ref":"RaftedValue.Members.html#start_replacing_leader/2","title":"RaftedValue.Members.start_replacing_leader/2","type":"function"},{"doc":"Type-aware getter for uncommitted_membership_change.","ref":"RaftedValue.Members.html#uncommitted_membership_change/1","title":"RaftedValue.Members.uncommitted_membership_change/1","type":"function"},{"doc":"Type-aware setter for uncommitted_membership_change.","ref":"RaftedValue.Members.html#uncommitted_membership_change/2","title":"RaftedValue.Members.uncommitted_membership_change/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.Members with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.Members.html#update/2","title":"RaftedValue.Members.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Members.html#update!/2","title":"RaftedValue.Members.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.Members.html#valid?/1","title":"RaftedValue.Members.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Members.html#t:t/0","title":"RaftedValue.Members.t/0","type":"type"},{"doc":"","ref":"RaftedValue.Monotonic.html","title":"RaftedValue.Monotonic","type":"module"},{"doc":"","ref":"RaftedValue.Monotonic.html#millis/0","title":"RaftedValue.Monotonic.millis/0","type":"function"},{"doc":"","ref":"RaftedValue.Monotonic.html#valid?/1","title":"RaftedValue.Monotonic.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Monotonic.html#t:t/0","title":"RaftedValue.Monotonic.t/0","type":"type"},{"doc":"","ref":"RaftedValue.Persistence.html","title":"RaftedValue.Persistence","type":"module"},{"doc":"Type-aware getter for dir.","ref":"RaftedValue.Persistence.html#dir/1","title":"RaftedValue.Persistence.dir/1","type":"function"},{"doc":"Type-aware setter for dir.","ref":"RaftedValue.Persistence.html#dir/2","title":"RaftedValue.Persistence.dir/2","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#find_log_files_containing_uncommitted_entries/2","title":"RaftedValue.Persistence.find_log_files_containing_uncommitted_entries/2","type":"function"},{"doc":"Type-aware getter for latest_snapshot_metadata.","ref":"RaftedValue.Persistence.html#latest_snapshot_metadata/1","title":"RaftedValue.Persistence.latest_snapshot_metadata/1","type":"function"},{"doc":"Type-aware setter for latest_snapshot_metadata.","ref":"RaftedValue.Persistence.html#latest_snapshot_metadata/2","title":"RaftedValue.Persistence.latest_snapshot_metadata/2","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#list_snapshots_in/1","title":"RaftedValue.Persistence.list_snapshots_in/1","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#log_compaction_runnable?/1","title":"RaftedValue.Persistence.log_compaction_runnable?/1","type":"function"},{"doc":"Type-aware getter for log_expansion_factor.","ref":"RaftedValue.Persistence.html#log_expansion_factor/1","title":"RaftedValue.Persistence.log_expansion_factor/1","type":"function"},{"doc":"Type-aware setter for log_expansion_factor.","ref":"RaftedValue.Persistence.html#log_expansion_factor/2","title":"RaftedValue.Persistence.log_expansion_factor/2","type":"function"},{"doc":"Type-aware getter for log_fd.","ref":"RaftedValue.Persistence.html#log_fd/1","title":"RaftedValue.Persistence.log_fd/1","type":"function"},{"doc":"Type-aware setter for log_fd.","ref":"RaftedValue.Persistence.html#log_fd/2","title":"RaftedValue.Persistence.log_fd/2","type":"function"},{"doc":"Type-aware getter for log_size_written.","ref":"RaftedValue.Persistence.html#log_size_written/1","title":"RaftedValue.Persistence.log_size_written/1","type":"function"},{"doc":"Type-aware setter for log_size_written.","ref":"RaftedValue.Persistence.html#log_size_written/2","title":"RaftedValue.Persistence.log_size_written/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.Persistence by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.Persistence.html#new/1","title":"RaftedValue.Persistence.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Persistence.html#new!/1","title":"RaftedValue.Persistence.new!/1","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#new_with_disk_snapshot/4","title":"RaftedValue.Persistence.new_with_disk_snapshot/4","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#new_with_initial_snapshotting/3","title":"RaftedValue.Persistence.new_with_initial_snapshotting/3","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#new_with_snapshot_sent_from_leader/3","title":"RaftedValue.Persistence.new_with_snapshot_sent_from_leader/3","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#read_last_log_index/1","title":"RaftedValue.Persistence.read_last_log_index/1","type":"function"},{"doc":"Type-aware getter for snapshot_writer.","ref":"RaftedValue.Persistence.html#snapshot_writer/1","title":"RaftedValue.Persistence.snapshot_writer/1","type":"function"},{"doc":"Type-aware setter for snapshot_writer.","ref":"RaftedValue.Persistence.html#snapshot_writer/2","title":"RaftedValue.Persistence.snapshot_writer/2","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#switch_log_file_and_spawn_snapshot_writer/3","title":"RaftedValue.Persistence.switch_log_file_and_spawn_snapshot_writer/3","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#unset_snapshot_metadata/1","title":"RaftedValue.Persistence.unset_snapshot_metadata/1","type":"function"},{"doc":"Updates an existing instance of RaftedValue.Persistence with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.Persistence.html#update/2","title":"RaftedValue.Persistence.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Persistence.html#update!/2","title":"RaftedValue.Persistence.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.Persistence.html#valid?/1","title":"RaftedValue.Persistence.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#write_log_entries/2","title":"RaftedValue.Persistence.write_log_entries/2","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.html#t:t/0","title":"RaftedValue.Persistence.t/0","type":"type"},{"doc":"","ref":"RaftedValue.Persistence.SnapshotMetadata.html","title":"RaftedValue.Persistence.SnapshotMetadata","type":"module"},{"doc":"Type-aware getter for last_committed_index.","ref":"RaftedValue.Persistence.SnapshotMetadata.html#last_committed_index/1","title":"RaftedValue.Persistence.SnapshotMetadata.last_committed_index/1","type":"function"},{"doc":"Type-aware setter for last_committed_index.","ref":"RaftedValue.Persistence.SnapshotMetadata.html#last_committed_index/2","title":"RaftedValue.Persistence.SnapshotMetadata.last_committed_index/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.Persistence.SnapshotMetadata by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.Persistence.SnapshotMetadata.html#new/1","title":"RaftedValue.Persistence.SnapshotMetadata.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Persistence.SnapshotMetadata.html#new!/1","title":"RaftedValue.Persistence.SnapshotMetadata.new!/1","type":"function"},{"doc":"Type-aware getter for path.","ref":"RaftedValue.Persistence.SnapshotMetadata.html#path/1","title":"RaftedValue.Persistence.SnapshotMetadata.path/1","type":"function"},{"doc":"Type-aware setter for path.","ref":"RaftedValue.Persistence.SnapshotMetadata.html#path/2","title":"RaftedValue.Persistence.SnapshotMetadata.path/2","type":"function"},{"doc":"Type-aware getter for size.","ref":"RaftedValue.Persistence.SnapshotMetadata.html#size/1","title":"RaftedValue.Persistence.SnapshotMetadata.size/1","type":"function"},{"doc":"Type-aware setter for size.","ref":"RaftedValue.Persistence.SnapshotMetadata.html#size/2","title":"RaftedValue.Persistence.SnapshotMetadata.size/2","type":"function"},{"doc":"Type-aware getter for term.","ref":"RaftedValue.Persistence.SnapshotMetadata.html#term/1","title":"RaftedValue.Persistence.SnapshotMetadata.term/1","type":"function"},{"doc":"Type-aware setter for term.","ref":"RaftedValue.Persistence.SnapshotMetadata.html#term/2","title":"RaftedValue.Persistence.SnapshotMetadata.term/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.Persistence.SnapshotMetadata with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.Persistence.SnapshotMetadata.html#update/2","title":"RaftedValue.Persistence.SnapshotMetadata.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Persistence.SnapshotMetadata.html#update!/2","title":"RaftedValue.Persistence.SnapshotMetadata.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.Persistence.SnapshotMetadata.html#valid?/1","title":"RaftedValue.Persistence.SnapshotMetadata.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Persistence.SnapshotMetadata.html#t:t/0","title":"RaftedValue.Persistence.SnapshotMetadata.t/0","type":"type"},{"doc":"","ref":"RaftedValue.RPC.html","title":"RaftedValue.RPC","type":"module"},{"doc":"","ref":"RaftedValue.RPC.AppendEntriesRequest.html","title":"RaftedValue.RPC.AppendEntriesRequest","type":"module"},{"doc":"Type-aware getter for entries.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#entries/1","title":"RaftedValue.RPC.AppendEntriesRequest.entries/1","type":"function"},{"doc":"Type-aware setter for entries.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#entries/2","title":"RaftedValue.RPC.AppendEntriesRequest.entries/2","type":"function"},{"doc":"Type-aware getter for i_leader_commit.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#i_leader_commit/1","title":"RaftedValue.RPC.AppendEntriesRequest.i_leader_commit/1","type":"function"},{"doc":"Type-aware setter for i_leader_commit.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#i_leader_commit/2","title":"RaftedValue.RPC.AppendEntriesRequest.i_leader_commit/2","type":"function"},{"doc":"Type-aware getter for leader_pid.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#leader_pid/1","title":"RaftedValue.RPC.AppendEntriesRequest.leader_pid/1","type":"function"},{"doc":"Type-aware setter for leader_pid.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#leader_pid/2","title":"RaftedValue.RPC.AppendEntriesRequest.leader_pid/2","type":"function"},{"doc":"Type-aware getter for leader_timestamp.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#leader_timestamp/1","title":"RaftedValue.RPC.AppendEntriesRequest.leader_timestamp/1","type":"function"},{"doc":"Type-aware setter for leader_timestamp.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#leader_timestamp/2","title":"RaftedValue.RPC.AppendEntriesRequest.leader_timestamp/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.RPC.AppendEntriesRequest by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.RPC.AppendEntriesRequest.html#new/1","title":"RaftedValue.RPC.AppendEntriesRequest.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.AppendEntriesRequest.html#new!/1","title":"RaftedValue.RPC.AppendEntriesRequest.new!/1","type":"function"},{"doc":"Type-aware getter for prev_log.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#prev_log/1","title":"RaftedValue.RPC.AppendEntriesRequest.prev_log/1","type":"function"},{"doc":"Type-aware setter for prev_log.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#prev_log/2","title":"RaftedValue.RPC.AppendEntriesRequest.prev_log/2","type":"function"},{"doc":"Type-aware getter for term.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#term/1","title":"RaftedValue.RPC.AppendEntriesRequest.term/1","type":"function"},{"doc":"Type-aware setter for term.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#term/2","title":"RaftedValue.RPC.AppendEntriesRequest.term/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.RPC.AppendEntriesRequest with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.RPC.AppendEntriesRequest.html#update/2","title":"RaftedValue.RPC.AppendEntriesRequest.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.AppendEntriesRequest.html#update!/2","title":"RaftedValue.RPC.AppendEntriesRequest.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.RPC.AppendEntriesRequest.html#valid?/1","title":"RaftedValue.RPC.AppendEntriesRequest.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.RPC.AppendEntriesRequest.html#t:t/0","title":"RaftedValue.RPC.AppendEntriesRequest.t/0","type":"type"},{"doc":"","ref":"RaftedValue.RPC.AppendEntriesResponse.html","title":"RaftedValue.RPC.AppendEntriesResponse","type":"module"},{"doc":"Type-aware getter for from.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#from/1","title":"RaftedValue.RPC.AppendEntriesResponse.from/1","type":"function"},{"doc":"Type-aware setter for from.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#from/2","title":"RaftedValue.RPC.AppendEntriesResponse.from/2","type":"function"},{"doc":"Type-aware getter for i_replicated.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#i_replicated/1","title":"RaftedValue.RPC.AppendEntriesResponse.i_replicated/1","type":"function"},{"doc":"Type-aware setter for i_replicated.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#i_replicated/2","title":"RaftedValue.RPC.AppendEntriesResponse.i_replicated/2","type":"function"},{"doc":"Type-aware getter for leader_timestamp.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#leader_timestamp/1","title":"RaftedValue.RPC.AppendEntriesResponse.leader_timestamp/1","type":"function"},{"doc":"Type-aware setter for leader_timestamp.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#leader_timestamp/2","title":"RaftedValue.RPC.AppendEntriesResponse.leader_timestamp/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.RPC.AppendEntriesResponse by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.RPC.AppendEntriesResponse.html#new/1","title":"RaftedValue.RPC.AppendEntriesResponse.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.AppendEntriesResponse.html#new!/1","title":"RaftedValue.RPC.AppendEntriesResponse.new!/1","type":"function"},{"doc":"Type-aware getter for success.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#success/1","title":"RaftedValue.RPC.AppendEntriesResponse.success/1","type":"function"},{"doc":"Type-aware setter for success.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#success/2","title":"RaftedValue.RPC.AppendEntriesResponse.success/2","type":"function"},{"doc":"Type-aware getter for term.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#term/1","title":"RaftedValue.RPC.AppendEntriesResponse.term/1","type":"function"},{"doc":"Type-aware setter for term.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#term/2","title":"RaftedValue.RPC.AppendEntriesResponse.term/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.RPC.AppendEntriesResponse with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.RPC.AppendEntriesResponse.html#update/2","title":"RaftedValue.RPC.AppendEntriesResponse.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.AppendEntriesResponse.html#update!/2","title":"RaftedValue.RPC.AppendEntriesResponse.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.RPC.AppendEntriesResponse.html#valid?/1","title":"RaftedValue.RPC.AppendEntriesResponse.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.RPC.AppendEntriesResponse.html#t:t/0","title":"RaftedValue.RPC.AppendEntriesResponse.t/0","type":"type"},{"doc":"","ref":"RaftedValue.RPC.InstallSnapshot.html","title":"RaftedValue.RPC.InstallSnapshot","type":"module"},{"doc":"Type-aware getter for command_results.","ref":"RaftedValue.RPC.InstallSnapshot.html#command_results/1","title":"RaftedValue.RPC.InstallSnapshot.command_results/1","type":"function"},{"doc":"Type-aware setter for command_results.","ref":"RaftedValue.RPC.InstallSnapshot.html#command_results/2","title":"RaftedValue.RPC.InstallSnapshot.command_results/2","type":"function"},{"doc":"Type-aware getter for config.","ref":"RaftedValue.RPC.InstallSnapshot.html#config/1","title":"RaftedValue.RPC.InstallSnapshot.config/1","type":"function"},{"doc":"Type-aware setter for config.","ref":"RaftedValue.RPC.InstallSnapshot.html#config/2","title":"RaftedValue.RPC.InstallSnapshot.config/2","type":"function"},{"doc":"Type-aware getter for data.","ref":"RaftedValue.RPC.InstallSnapshot.html#data/1","title":"RaftedValue.RPC.InstallSnapshot.data/1","type":"function"},{"doc":"Type-aware setter for data.","ref":"RaftedValue.RPC.InstallSnapshot.html#data/2","title":"RaftedValue.RPC.InstallSnapshot.data/2","type":"function"},{"doc":"Type-aware getter for last_committed_entry.","ref":"RaftedValue.RPC.InstallSnapshot.html#last_committed_entry/1","title":"RaftedValue.RPC.InstallSnapshot.last_committed_entry/1","type":"function"},{"doc":"Type-aware setter for last_committed_entry.","ref":"RaftedValue.RPC.InstallSnapshot.html#last_committed_entry/2","title":"RaftedValue.RPC.InstallSnapshot.last_committed_entry/2","type":"function"},{"doc":"Type-aware getter for members.","ref":"RaftedValue.RPC.InstallSnapshot.html#members/1","title":"RaftedValue.RPC.InstallSnapshot.members/1","type":"function"},{"doc":"Type-aware setter for members.","ref":"RaftedValue.RPC.InstallSnapshot.html#members/2","title":"RaftedValue.RPC.InstallSnapshot.members/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.RPC.InstallSnapshot by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.RPC.InstallSnapshot.html#new/1","title":"RaftedValue.RPC.InstallSnapshot.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.InstallSnapshot.html#new!/1","title":"RaftedValue.RPC.InstallSnapshot.new!/1","type":"function"},{"doc":"Type-aware getter for term.","ref":"RaftedValue.RPC.InstallSnapshot.html#term/1","title":"RaftedValue.RPC.InstallSnapshot.term/1","type":"function"},{"doc":"Type-aware setter for term.","ref":"RaftedValue.RPC.InstallSnapshot.html#term/2","title":"RaftedValue.RPC.InstallSnapshot.term/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.RPC.InstallSnapshot with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.RPC.InstallSnapshot.html#update/2","title":"RaftedValue.RPC.InstallSnapshot.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.InstallSnapshot.html#update!/2","title":"RaftedValue.RPC.InstallSnapshot.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.RPC.InstallSnapshot.html#valid?/1","title":"RaftedValue.RPC.InstallSnapshot.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.RPC.InstallSnapshot.html#t:t/0","title":"RaftedValue.RPC.InstallSnapshot.t/0","type":"type"},{"doc":"","ref":"RaftedValue.RPC.InstallSnapshotCompressed.html","title":"RaftedValue.RPC.InstallSnapshotCompressed","type":"module"},{"doc":"Type-aware getter for bin.","ref":"RaftedValue.RPC.InstallSnapshotCompressed.html#bin/1","title":"RaftedValue.RPC.InstallSnapshotCompressed.bin/1","type":"function"},{"doc":"Type-aware setter for bin.","ref":"RaftedValue.RPC.InstallSnapshotCompressed.html#bin/2","title":"RaftedValue.RPC.InstallSnapshotCompressed.bin/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.RPC.InstallSnapshotCompressed by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.RPC.InstallSnapshotCompressed.html#new/1","title":"RaftedValue.RPC.InstallSnapshotCompressed.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.InstallSnapshotCompressed.html#new!/1","title":"RaftedValue.RPC.InstallSnapshotCompressed.new!/1","type":"function"},{"doc":"Updates an existing instance of RaftedValue.RPC.InstallSnapshotCompressed with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.RPC.InstallSnapshotCompressed.html#update/2","title":"RaftedValue.RPC.InstallSnapshotCompressed.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.InstallSnapshotCompressed.html#update!/2","title":"RaftedValue.RPC.InstallSnapshotCompressed.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.RPC.InstallSnapshotCompressed.html#valid?/1","title":"RaftedValue.RPC.InstallSnapshotCompressed.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.RPC.InstallSnapshotCompressed.html#t:t/0","title":"RaftedValue.RPC.InstallSnapshotCompressed.t/0","type":"type"},{"doc":"","ref":"RaftedValue.RPC.RequestVoteRequest.html","title":"RaftedValue.RPC.RequestVoteRequest","type":"module"},{"doc":"Type-aware getter for candidate_pid.","ref":"RaftedValue.RPC.RequestVoteRequest.html#candidate_pid/1","title":"RaftedValue.RPC.RequestVoteRequest.candidate_pid/1","type":"function"},{"doc":"Type-aware setter for candidate_pid.","ref":"RaftedValue.RPC.RequestVoteRequest.html#candidate_pid/2","title":"RaftedValue.RPC.RequestVoteRequest.candidate_pid/2","type":"function"},{"doc":"Type-aware getter for last_log.","ref":"RaftedValue.RPC.RequestVoteRequest.html#last_log/1","title":"RaftedValue.RPC.RequestVoteRequest.last_log/1","type":"function"},{"doc":"Type-aware setter for last_log.","ref":"RaftedValue.RPC.RequestVoteRequest.html#last_log/2","title":"RaftedValue.RPC.RequestVoteRequest.last_log/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.RPC.RequestVoteRequest by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.RPC.RequestVoteRequest.html#new/1","title":"RaftedValue.RPC.RequestVoteRequest.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.RequestVoteRequest.html#new!/1","title":"RaftedValue.RPC.RequestVoteRequest.new!/1","type":"function"},{"doc":"Type-aware getter for replacing_leader.","ref":"RaftedValue.RPC.RequestVoteRequest.html#replacing_leader/1","title":"RaftedValue.RPC.RequestVoteRequest.replacing_leader/1","type":"function"},{"doc":"Type-aware setter for replacing_leader.","ref":"RaftedValue.RPC.RequestVoteRequest.html#replacing_leader/2","title":"RaftedValue.RPC.RequestVoteRequest.replacing_leader/2","type":"function"},{"doc":"Type-aware getter for term.","ref":"RaftedValue.RPC.RequestVoteRequest.html#term/1","title":"RaftedValue.RPC.RequestVoteRequest.term/1","type":"function"},{"doc":"Type-aware setter for term.","ref":"RaftedValue.RPC.RequestVoteRequest.html#term/2","title":"RaftedValue.RPC.RequestVoteRequest.term/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.RPC.RequestVoteRequest with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.RPC.RequestVoteRequest.html#update/2","title":"RaftedValue.RPC.RequestVoteRequest.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.RequestVoteRequest.html#update!/2","title":"RaftedValue.RPC.RequestVoteRequest.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.RPC.RequestVoteRequest.html#valid?/1","title":"RaftedValue.RPC.RequestVoteRequest.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.RPC.RequestVoteRequest.html#t:t/0","title":"RaftedValue.RPC.RequestVoteRequest.t/0","type":"type"},{"doc":"","ref":"RaftedValue.RPC.RequestVoteResponse.html","title":"RaftedValue.RPC.RequestVoteResponse","type":"module"},{"doc":"Type-aware getter for from.","ref":"RaftedValue.RPC.RequestVoteResponse.html#from/1","title":"RaftedValue.RPC.RequestVoteResponse.from/1","type":"function"},{"doc":"Type-aware setter for from.","ref":"RaftedValue.RPC.RequestVoteResponse.html#from/2","title":"RaftedValue.RPC.RequestVoteResponse.from/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.RPC.RequestVoteResponse by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.RPC.RequestVoteResponse.html#new/1","title":"RaftedValue.RPC.RequestVoteResponse.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.RequestVoteResponse.html#new!/1","title":"RaftedValue.RPC.RequestVoteResponse.new!/1","type":"function"},{"doc":"Type-aware getter for term.","ref":"RaftedValue.RPC.RequestVoteResponse.html#term/1","title":"RaftedValue.RPC.RequestVoteResponse.term/1","type":"function"},{"doc":"Type-aware setter for term.","ref":"RaftedValue.RPC.RequestVoteResponse.html#term/2","title":"RaftedValue.RPC.RequestVoteResponse.term/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.RPC.RequestVoteResponse with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.RPC.RequestVoteResponse.html#update/2","title":"RaftedValue.RPC.RequestVoteResponse.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.RequestVoteResponse.html#update!/2","title":"RaftedValue.RPC.RequestVoteResponse.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.RPC.RequestVoteResponse.html#valid?/1","title":"RaftedValue.RPC.RequestVoteResponse.valid?/1","type":"function"},{"doc":"Type-aware getter for vote_granted.","ref":"RaftedValue.RPC.RequestVoteResponse.html#vote_granted/1","title":"RaftedValue.RPC.RequestVoteResponse.vote_granted/1","type":"function"},{"doc":"Type-aware setter for vote_granted.","ref":"RaftedValue.RPC.RequestVoteResponse.html#vote_granted/2","title":"RaftedValue.RPC.RequestVoteResponse.vote_granted/2","type":"function"},{"doc":"","ref":"RaftedValue.RPC.RequestVoteResponse.html#t:t/0","title":"RaftedValue.RPC.RequestVoteResponse.t/0","type":"type"},{"doc":"","ref":"RaftedValue.RPC.TimeoutNow.html","title":"RaftedValue.RPC.TimeoutNow","type":"module"},{"doc":"Type-aware getter for append_entries_req.","ref":"RaftedValue.RPC.TimeoutNow.html#append_entries_req/1","title":"RaftedValue.RPC.TimeoutNow.append_entries_req/1","type":"function"},{"doc":"Type-aware setter for append_entries_req.","ref":"RaftedValue.RPC.TimeoutNow.html#append_entries_req/2","title":"RaftedValue.RPC.TimeoutNow.append_entries_req/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.RPC.TimeoutNow by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.RPC.TimeoutNow.html#new/1","title":"RaftedValue.RPC.TimeoutNow.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.TimeoutNow.html#new!/1","title":"RaftedValue.RPC.TimeoutNow.new!/1","type":"function"},{"doc":"Updates an existing instance of RaftedValue.RPC.TimeoutNow with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.RPC.TimeoutNow.html#update/2","title":"RaftedValue.RPC.TimeoutNow.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.RPC.TimeoutNow.html#update!/2","title":"RaftedValue.RPC.TimeoutNow.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.RPC.TimeoutNow.html#valid?/1","title":"RaftedValue.RPC.TimeoutNow.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.RPC.TimeoutNow.html#t:t/0","title":"RaftedValue.RPC.TimeoutNow.t/0","type":"type"},{"doc":"Default implementation of :communication_module . Essentially cast/2 behaves as :gen_statem.cast/2 and reply/2 behaves as :gen_statem.reply/2 . This is introduced in order to work-around slow message passing to unreachable nodes; if the target node is not connected to Node.self() , functions in this node give up delivering message. In order to recover from temporary network issues, reconnecting to disconnected nodes should be tried elsewhere. Note that :raft_fleet (since 0.5.0) periodically tries to re-establish inter-node connections out of the box.","ref":"RaftedValue.RemoteMessageGateway.html","title":"RaftedValue.RemoteMessageGateway","type":"module"},{"doc":"Callback implementation for RaftedValue.Communication.cast/2 .","ref":"RaftedValue.RemoteMessageGateway.html#cast/2","title":"RaftedValue.RemoteMessageGateway.cast/2","type":"function"},{"doc":"Callback implementation for RaftedValue.Communication.reply/2 .","ref":"RaftedValue.RemoteMessageGateway.html#reply/2","title":"RaftedValue.RemoteMessageGateway.reply/2","type":"function"},{"doc":"","ref":"RaftedValue.Server.html","title":"RaftedValue.Server","type":"module"},{"doc":"","ref":"RaftedValue.Server.html#become_leader/1","title":"RaftedValue.Server.become_leader/1","type":"function"},{"doc":"Callback implementation for :gen_statem.callback_mode/0 .","ref":"RaftedValue.Server.html#callback_mode/0","title":"RaftedValue.Server.callback_mode/0","type":"function"},{"doc":"","ref":"RaftedValue.Server.html#candidate/3","title":"RaftedValue.Server.candidate/3","type":"function"},{"doc":"Callback implementation for :gen_statem.code_change/4 .","ref":"RaftedValue.Server.html#code_change/4","title":"RaftedValue.Server.code_change/4","type":"function"},{"doc":"","ref":"RaftedValue.Server.html#follower/3","title":"RaftedValue.Server.follower/3","type":"function"},{"doc":"","ref":"RaftedValue.Server.html#handle_info_common/3","title":"RaftedValue.Server.handle_info_common/3","type":"function"},{"doc":"Callback implementation for :gen_statem.init/1 .","ref":"RaftedValue.Server.html#init/1","title":"RaftedValue.Server.init/1","type":"function"},{"doc":"","ref":"RaftedValue.Server.html#leader/3","title":"RaftedValue.Server.leader/3","type":"function"},{"doc":"Callback implementation for :gen_statem.terminate/3 .","ref":"RaftedValue.Server.html#terminate/3","title":"RaftedValue.Server.terminate/3","type":"function"},{"doc":"","ref":"RaftedValue.Server.State.html","title":"RaftedValue.Server.State","type":"module"},{"doc":"Type-aware getter for command_results.","ref":"RaftedValue.Server.State.html#command_results/1","title":"RaftedValue.Server.State.command_results/1","type":"function"},{"doc":"Type-aware setter for command_results.","ref":"RaftedValue.Server.State.html#command_results/2","title":"RaftedValue.Server.State.command_results/2","type":"function"},{"doc":"Type-aware getter for config.","ref":"RaftedValue.Server.State.html#config/1","title":"RaftedValue.Server.State.config/1","type":"function"},{"doc":"Type-aware setter for config.","ref":"RaftedValue.Server.State.html#config/2","title":"RaftedValue.Server.State.config/2","type":"function"},{"doc":"Type-aware getter for current_term.","ref":"RaftedValue.Server.State.html#current_term/1","title":"RaftedValue.Server.State.current_term/1","type":"function"},{"doc":"Type-aware setter for current_term.","ref":"RaftedValue.Server.State.html#current_term/2","title":"RaftedValue.Server.State.current_term/2","type":"function"},{"doc":"Type-aware getter for data.","ref":"RaftedValue.Server.State.html#data/1","title":"RaftedValue.Server.State.data/1","type":"function"},{"doc":"Type-aware setter for data.","ref":"RaftedValue.Server.State.html#data/2","title":"RaftedValue.Server.State.data/2","type":"function"},{"doc":"Type-aware getter for election.","ref":"RaftedValue.Server.State.html#election/1","title":"RaftedValue.Server.State.election/1","type":"function"},{"doc":"Type-aware setter for election.","ref":"RaftedValue.Server.State.html#election/2","title":"RaftedValue.Server.State.election/2","type":"function"},{"doc":"Type-aware getter for leadership.","ref":"RaftedValue.Server.State.html#leadership/1","title":"RaftedValue.Server.State.leadership/1","type":"function"},{"doc":"Type-aware setter for leadership.","ref":"RaftedValue.Server.State.html#leadership/2","title":"RaftedValue.Server.State.leadership/2","type":"function"},{"doc":"Type-aware getter for logs.","ref":"RaftedValue.Server.State.html#logs/1","title":"RaftedValue.Server.State.logs/1","type":"function"},{"doc":"Type-aware setter for logs.","ref":"RaftedValue.Server.State.html#logs/2","title":"RaftedValue.Server.State.logs/2","type":"function"},{"doc":"Type-aware getter for members.","ref":"RaftedValue.Server.State.html#members/1","title":"RaftedValue.Server.State.members/1","type":"function"},{"doc":"Type-aware setter for members.","ref":"RaftedValue.Server.State.html#members/2","title":"RaftedValue.Server.State.members/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.Server.State by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.Server.State.html#new/1","title":"RaftedValue.Server.State.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Server.State.html#new!/1","title":"RaftedValue.Server.State.new!/1","type":"function"},{"doc":"Type-aware getter for persistence.","ref":"RaftedValue.Server.State.html#persistence/1","title":"RaftedValue.Server.State.persistence/1","type":"function"},{"doc":"Type-aware setter for persistence.","ref":"RaftedValue.Server.State.html#persistence/2","title":"RaftedValue.Server.State.persistence/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.Server.State with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.Server.State.html#update/2","title":"RaftedValue.Server.State.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Server.State.html#update!/2","title":"RaftedValue.Server.State.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.Server.State.html#valid?/1","title":"RaftedValue.Server.State.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Server.State.html#t:t/0","title":"RaftedValue.Server.State.t/0","type":"type"},{"doc":"","ref":"RaftedValue.Snapshot.html","title":"RaftedValue.Snapshot","type":"module"},{"doc":"Type-aware getter for command_results.","ref":"RaftedValue.Snapshot.html#command_results/1","title":"RaftedValue.Snapshot.command_results/1","type":"function"},{"doc":"Type-aware setter for command_results.","ref":"RaftedValue.Snapshot.html#command_results/2","title":"RaftedValue.Snapshot.command_results/2","type":"function"},{"doc":"Type-aware getter for config.","ref":"RaftedValue.Snapshot.html#config/1","title":"RaftedValue.Snapshot.config/1","type":"function"},{"doc":"Type-aware setter for config.","ref":"RaftedValue.Snapshot.html#config/2","title":"RaftedValue.Snapshot.config/2","type":"function"},{"doc":"Type-aware getter for data.","ref":"RaftedValue.Snapshot.html#data/1","title":"RaftedValue.Snapshot.data/1","type":"function"},{"doc":"Type-aware setter for data.","ref":"RaftedValue.Snapshot.html#data/2","title":"RaftedValue.Snapshot.data/2","type":"function"},{"doc":"","ref":"RaftedValue.Snapshot.html#decode/1","title":"RaftedValue.Snapshot.decode/1","type":"function"},{"doc":"","ref":"RaftedValue.Snapshot.html#encode/1","title":"RaftedValue.Snapshot.encode/1","type":"function"},{"doc":"","ref":"RaftedValue.Snapshot.html#from_install_snapshot/1","title":"RaftedValue.Snapshot.from_install_snapshot/1","type":"function"},{"doc":"Type-aware getter for last_committed_entry.","ref":"RaftedValue.Snapshot.html#last_committed_entry/1","title":"RaftedValue.Snapshot.last_committed_entry/1","type":"function"},{"doc":"Type-aware setter for last_committed_entry.","ref":"RaftedValue.Snapshot.html#last_committed_entry/2","title":"RaftedValue.Snapshot.last_committed_entry/2","type":"function"},{"doc":"Type-aware getter for members.","ref":"RaftedValue.Snapshot.html#members/1","title":"RaftedValue.Snapshot.members/1","type":"function"},{"doc":"Type-aware setter for members.","ref":"RaftedValue.Snapshot.html#members/2","title":"RaftedValue.Snapshot.members/2","type":"function"},{"doc":"Creates a new instance of RaftedValue.Snapshot by using the given dict . Values associated with the struct field names are fetched from the given dict and then validated/converted with valid?/1 / new/1 . For missing fields default values (if any) are used. Returns {:ok, valid_struct} when all fields are filled with valid values. Returns {:error, reason} if any error occurs (invalid value or no value is available). See also moduledoc of Croma.Struct .","ref":"RaftedValue.Snapshot.html#new/1","title":"RaftedValue.Snapshot.new/1","type":"function"},{"doc":"A variant of new/1 which returns t or raise if validation fails. In other words, new/1 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Snapshot.html#new!/1","title":"RaftedValue.Snapshot.new!/1","type":"function"},{"doc":"","ref":"RaftedValue.Snapshot.html#read_latest_snapshot_and_logs_if_available/1","title":"RaftedValue.Snapshot.read_latest_snapshot_and_logs_if_available/1","type":"function"},{"doc":"Type-aware getter for term.","ref":"RaftedValue.Snapshot.html#term/1","title":"RaftedValue.Snapshot.term/1","type":"function"},{"doc":"Type-aware setter for term.","ref":"RaftedValue.Snapshot.html#term/2","title":"RaftedValue.Snapshot.term/2","type":"function"},{"doc":"Updates an existing instance of RaftedValue.Snapshot with the given dict . The values in the dict are validated by each field's valid?/1 function. Returns {:ok, valid_struct} or {:error, reason} .","ref":"RaftedValue.Snapshot.html#update/2","title":"RaftedValue.Snapshot.update/2","type":"function"},{"doc":"A variant of update/2 which returns t or raise if validation fails. In other words, update/2 followed by Croma.Result.get!/1 .","ref":"RaftedValue.Snapshot.html#update!/2","title":"RaftedValue.Snapshot.update!/2","type":"function"},{"doc":"Checks if the given value belongs to t/0 or not.","ref":"RaftedValue.Snapshot.html#valid?/1","title":"RaftedValue.Snapshot.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.Snapshot.html#t:t/0","title":"RaftedValue.Snapshot.t/0","type":"type"},{"doc":"","ref":"RaftedValue.TermNumber.html","title":"RaftedValue.TermNumber","type":"module"},{"doc":"","ref":"RaftedValue.TermNumber.html#min/0","title":"RaftedValue.TermNumber.min/0","type":"function"},{"doc":"","ref":"RaftedValue.TermNumber.html#valid?/1","title":"RaftedValue.TermNumber.valid?/1","type":"function"},{"doc":"","ref":"RaftedValue.TermNumber.html#t:t/0","title":"RaftedValue.TermNumber.t/0","type":"type"},{"doc":"","ref":"RaftedValue.Timer.html","title":"RaftedValue.Timer","type":"module"},{"doc":"","ref":"RaftedValue.Timer.html#cancel/1","title":"RaftedValue.Timer.cancel/1","type":"function"},{"doc":"","ref":"RaftedValue.Timer.html#make/2","title":"RaftedValue.Timer.make/2","type":"function"},{"doc":"","ref":"RaftedValue.AddFollowerError.html","title":"RaftedValue.AddFollowerError","type":"exception"}]